typedef unsigned char byte;

typedef unsigned short word;

typedef unsigned long dword;


typedef union {
  struct {
    byte pm0mode:2;
    byte pm02:1;
    byte pm03:1;
    byte pm045:1;
    byte unspec_0:1;
    byte pm07:1;
  };
  byte b;
} pm0_type;
#define pm0 (*(volatile pm0_type *)0x04)

typedef union {
  struct {
    byte pm1mode:1;
    byte pm12:1;
    byte unspec_0:1;
    byte pm1ale:2;
    byte unspec_1:1;
    byte unspec_2:1;
  };
  byte b;
} pm1_type;
#define pm1 (*(volatile pm1_type *)0x05)

#define cm0 (*(volatile byte *)0x06)
#define cm1 (*(volatile byte *)0x07)

typedef union {
  struct {
    byte prc0:1;
    byte prc1:1;
    byte prc2:1;
    byte prc3:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} prcr_type;
#define prcr (*(volatile prcr_type *)0x0a)

#define mcd (*(volatile byte *)0x0c)
#define ds (*(volatile byte *)0x0b)
#define ewcr0 (*(volatile byte *)0x48)
#define ewcr1 (*(volatile byte *)0x49)
#define ewcr2 (*(volatile byte *)0x4a)
#define ewcr3 (*(volatile byte *)0x4b)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd0_type;
#define pd0 (*(volatile pd0_type *)0x03e2)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd1_type;
#define pd1 (*(volatile pd1_type *)0x03e3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd2_type;
#define pd2 (*(volatile pd2_type *)0x03e6)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd3_type;
#define pd3 (*(volatile pd3_type *)0x03e7)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd4_type;
#define pd4 (*(volatile pd4_type *)0x03ea)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd5_type;
#define pd5 (*(volatile pd5_type *)0x03eb)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd6_type;
#define pd6 (*(volatile pd6_type *)0x03c2)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd7_type;
#define pd7 (*(volatile pd7_type *)0x03c3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd8_type;
#define pd8 (*(volatile pd8_type *)0x03c6)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd9_type;
#define pd9 (*(volatile pd9_type *)0x03c7)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd10_type;
#define pd10 (*(volatile pd10_type *)0x03ca)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd11_type;
#define pd11 (*(volatile pd11_type *)0x03cb)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd12_type;
#define pd12 (*(volatile pd12_type *)0x03ce)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd13_type;
#define pd13 (*(volatile pd13_type *)0x03cf)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd14_type;
#define pd14 (*(volatile pd14_type *)0x03d2)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd15_type;
#define pd15 (*(volatile pd15_type *)0x03d3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p0_type;
#define p0 (*(volatile p0_type *)0x03e0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p1_type;
#define p1 (*(volatile p1_type *)0x03e1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p2_type;
#define p2 (*(volatile p2_type *)0x03e4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p3_type;
#define p3 (*(volatile p3_type *)0x03e5)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p4_type;
#define p4 (*(volatile p4_type *)0x03e8)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p5_type;
#define p5 (*(volatile p5_type *)0x03e9)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p6_type;
#define p6 (*(volatile p6_type *)0x03c0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p7_type;
#define p7 (*(volatile p7_type *)0x03c1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p8_type;
#define p8 (*(volatile p8_type *)0x03c4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p9_type;
#define p9 (*(volatile p9_type *)0x03c5)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p10_type;
#define p10 (*(volatile p10_type *)0x03c8)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p11_type;
#define p11 (*(volatile p11_type *)0x03c9)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p12_type;
#define p12 (*(volatile p12_type *)0x03cc)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p13_type;
#define p13 (*(volatile p13_type *)0x03cd)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p14_type;
#define p14 (*(volatile p14_type *)0x03d0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p15_type;
#define p15 (*(volatile p15_type *)0x03d1)

#define u0tb (*(volatile byte *)0x036a)
#define u1tb (*(volatile byte *)0x02ea)
#define u2tb (*(volatile byte *)0x033a)
#define u3tb (*(volatile byte *)0x032a)
#define u4tb (*(volatile byte *)0x02fa)
#define u5tb (*(volatile byte *)0x01c2)
#define u6tb (*(volatile byte *)0x01ca)
#define u0rb (*(volatile byte *)0x036e)
#define u1rb (*(volatile byte *)0x02ee)
#define u2rb (*(volatile byte *)0x033e)
#define u3rb (*(volatile byte *)0x032e)
#define u4rb (*(volatile byte *)0x02fe)
#define u5rb (*(volatile byte *)0x01c6)
#define u6rb (*(volatile byte *)0x01ce)
#define u0brg (*(volatile byte *)0x0369)
#define u1brg (*(volatile byte *)0x02e9)
#define u2brg (*(volatile byte *)0x0339)
#define u3brg (*(volatile byte *)0x0329)
#define u4brg (*(volatile byte *)0x02f9)
#define u5brg (*(volatile byte *)0x01c1)
#define u6brg (*(volatile byte *)0x01c9)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte iopol:1;
  };
  byte b;
} u0mr_type;
#define u0mr (*(volatile u0mr_type *)0x0368)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte iopol:1;
  };
  byte b;
} u1mr_type;
#define u1mr (*(volatile u1mr_type *)0x02e8)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte iopol:1;
  };
  byte b;
} u2mr_type;
#define u2mr (*(volatile u2mr_type *)0x0338)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte iopol:1;
  };
  byte b;
} u3mr_type;
#define u3mr (*(volatile u3mr_type *)0x0328)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte iopol:1;
  };
  byte b;
} u4mr_type;
#define u4mr (*(volatile u4mr_type *)0x02f8)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte unspec_0:1;
  };
  byte b;
} u5mr_type;
#define u5mr (*(volatile u5mr_type *)0x01c0)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte unspec_0:1;
  };
  byte b;
} u6mr_type;
#define u6mr (*(volatile u6mr_type *)0x01c8)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u0c0_type;
#define u0c0 (*(volatile u0c0_type *)0x036c)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u1c0_type;
#define u1c0 (*(volatile u1c0_type *)0x02ec)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u2c0_type;
#define u2c0 (*(volatile u2c0_type *)0x033c)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u3c0_type;
#define u3c0 (*(volatile u3c0_type *)0x032c)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u4c0_type;
#define u4c0 (*(volatile u4c0_type *)0x02fc)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u5c0_type;
#define u5c0 (*(volatile u5c0_type *)0x01c4)

typedef union {
  struct {
    byte clk:2;
    byte crs:1;
    byte txept:1;
    byte crd:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u6c0_type;
#define u6c0 (*(volatile u6c0_type *)0x01cc)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte uiirs:1;
    byte uirrm:1;
    byte uilch:1;
    byte sclkstpb:1;
  };
  byte b;
} u0c1_type;
#define u0c1 (*(volatile u0c1_type *)0x036d)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte uiirs:1;
    byte uirrm:1;
    byte uilch:1;
    byte sclkstpb:1;
  };
  byte b;
} u1c1_type;
#define u1c1 (*(volatile u1c1_type *)0x02ed)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte uiirs:1;
    byte uirrm:1;
    byte uilch:1;
    byte sclkstpb:1;
  };
  byte b;
} u2c1_type;
#define u2c1 (*(volatile u2c1_type *)0x033d)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte uiirs:1;
    byte uirrm:1;
    byte uilch:1;
    byte sclkstpb:1;
  };
  byte b;
} u3c1_type;
#define u3c1 (*(volatile u3c1_type *)0x032d)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte uiirs:1;
    byte uirrm:1;
    byte uilch:1;
    byte sclkstpb:1;
  };
  byte b;
} u4c1_type;
#define u4c1 (*(volatile u4c1_type *)0x02fd)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} u5c1_type;
#define u5c1 (*(volatile u5c1_type *)0x01c5)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} u6c1_type;
#define u6c1 (*(volatile u6c1_type *)0x01cd)

typedef union {
  struct {
    byte u5irs:1;
    byte u6irs:1;
    byte u5rrm:1;
    byte u6rrm:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} u56con_type;
#define u56con (*(volatile u56con_type *)0x01d0)

typedef union {
  struct {
    byte iicm:1;
    byte abc:1;
    byte bbs:1;
    byte lsyn:1;
    byte abscs:1;
    byte acse:1;
    byte sss:1;
    byte sclkdiv:1;
  };
  byte b;
} u0smr_type;
#define u0smr (*(volatile u0smr_type *)0x0367)

typedef union {
  struct {
    byte iicm:1;
    byte abc:1;
    byte bbs:1;
    byte lsyn:1;
    byte abscs:1;
    byte acse:1;
    byte sss:1;
    byte sclkdiv:1;
  };
  byte b;
} u1smr_type;
#define u1smr (*(volatile u1smr_type *)0x02e7)

typedef union {
  struct {
    byte iicm:1;
    byte abc:1;
    byte bbs:1;
    byte lsyn:1;
    byte abscs:1;
    byte acse:1;
    byte sss:1;
    byte sclkdiv:1;
  };
  byte b;
} u2smr_type;
#define u2smr (*(volatile u2smr_type *)0x0337)

typedef union {
  struct {
    byte iicm:1;
    byte abc:1;
    byte bbs:1;
    byte lsyn:1;
    byte abscs:1;
    byte acse:1;
    byte sss:1;
    byte sclkdiv:1;
  };
  byte b;
} u3smr_type;
#define u3smr (*(volatile u3smr_type *)0x0327)

typedef union {
  struct {
    byte iicm:1;
    byte abc:1;
    byte bbs:1;
    byte lsyn:1;
    byte abscs:1;
    byte acse:1;
    byte sss:1;
    byte sclkdiv:1;
  };
  byte b;
} u4smr_type;
#define u4smr (*(volatile u4smr_type *)0x02f7)

typedef union {
  struct {
    byte iicm2:1;
    byte csc:1;
    byte swc:1;
    byte als:1;
    byte stc:1;
    byte swc2:1;
    byte sdhi:1;
    byte su1him:1;
  };
  byte b;
} u0smr2_type;
#define u0smr2 (*(volatile u0smr2_type *)0x0366)

typedef union {
  struct {
    byte iicm2:1;
    byte csc:1;
    byte swc:1;
    byte als:1;
    byte stc:1;
    byte swc2:1;
    byte sdhi:1;
    byte su1him:1;
  };
  byte b;
} u1smr2_type;
#define u1smr2 (*(volatile u1smr2_type *)0x02e6)

typedef union {
  struct {
    byte iicm2:1;
    byte csc:1;
    byte swc:1;
    byte als:1;
    byte stc:1;
    byte swc2:1;
    byte sdhi:1;
    byte su1him:1;
  };
  byte b;
} u2smr2_type;
#define u2smr2 (*(volatile u2smr2_type *)0x0336)

typedef union {
  struct {
    byte iicm2:1;
    byte csc:1;
    byte swc:1;
    byte als:1;
    byte stc:1;
    byte swc2:1;
    byte sdhi:1;
    byte su1him:1;
  };
  byte b;
} u3smr2_type;
#define u3smr2 (*(volatile u3smr2_type *)0x0326)

typedef union {
  struct {
    byte iicm2:1;
    byte csc:1;
    byte swc:1;
    byte als:1;
    byte stc:1;
    byte swc2:1;
    byte sdhi:1;
    byte su1him:1;
  };
  byte b;
} u4smr2_type;
#define u4smr2 (*(volatile u4smr2_type *)0x02f6)

typedef union {
  struct {
    byte sse:1;
    byte ckph:1;
    byte dinc:1;
    byte nodc:1;
    byte err:1;
    byte sl:3;
  };
  byte b;
} u0smr3_type;
#define u0smr3 (*(volatile u0smr3_type *)0x0365)

typedef union {
  struct {
    byte sse:1;
    byte ckph:1;
    byte dinc:1;
    byte nodc:1;
    byte err:1;
    byte sl:3;
  };
  byte b;
} u1smr3_type;
#define u1smr3 (*(volatile u1smr3_type *)0x02e5)

typedef union {
  struct {
    byte sse:1;
    byte ckph:1;
    byte dinc:1;
    byte nodc:1;
    byte err:1;
    byte sl:3;
  };
  byte b;
} u2smr3_type;
#define u2smr3 (*(volatile u2smr3_type *)0x0335)

typedef union {
  struct {
    byte sse:1;
    byte ckph:1;
    byte dinc:1;
    byte nodc:1;
    byte err:1;
    byte sl:3;
  };
  byte b;
} u3smr3_type;
#define u3smr3 (*(volatile u3smr3_type *)0x0325)

typedef union {
  struct {
    byte sse:1;
    byte ckph:1;
    byte dinc:1;
    byte nodc:1;
    byte err:1;
    byte sl:3;
  };
  byte b;
} u4smr3_type;
#define u4smr3 (*(volatile u4smr3_type *)0x02f5)

typedef union {
  struct {
    byte stareq:1;
    byte rstareq:1;
    byte stpreq:1;
    byte stspsel:1;
    byte ackd:1;
    byte ackc:1;
    byte sclhi:1;
    byte swc9:1;
  };
  byte b;
} u0smr4_type;
#define u0smr4 (*(volatile u0smr4_type *)0x0364)

typedef union {
  struct {
    byte stareq:1;
    byte rstareq:1;
    byte stpreq:1;
    byte stspsel:1;
    byte ackd:1;
    byte ackc:1;
    byte sclhi:1;
    byte swc9:1;
  };
  byte b;
} u1smr4_type;
#define u1smr4 (*(volatile u1smr4_type *)0x02e4)

typedef union {
  struct {
    byte stareq:1;
    byte rstareq:1;
    byte stpreq:1;
    byte stspsel:1;
    byte ackd:1;
    byte ackc:1;
    byte sclhi:1;
    byte swc9:1;
  };
  byte b;
} u2smr4_type;
#define u2smr4 (*(volatile u2smr4_type *)0x0334)

typedef union {
  struct {
    byte stareq:1;
    byte rstareq:1;
    byte stpreq:1;
    byte stspsel:1;
    byte ackd:1;
    byte ackc:1;
    byte sclhi:1;
    byte swc9:1;
  };
  byte b;
} u3smr4_type;
#define u3smr4 (*(volatile u3smr4_type *)0x0324)

typedef union {
  struct {
    byte stareq:1;
    byte rstareq:1;
    byte stpreq:1;
    byte stspsel:1;
    byte ackd:1;
    byte ackc:1;
    byte sclhi:1;
    byte swc9:1;
  };
  byte b;
} u4smr4_type;
#define u4smr4 (*(volatile u4smr4_type *)0x02f4)

#define ifsr (*(volatile byte *)0x031f)

typedef union {
  struct {
    byte u5clk:1;
    byte u5rxd:1;
    byte u5cts:1;
    byte unspec_0:1;
    byte u6clk:1;
    byte u6rxd:1;
    byte u6cts:1;
    byte unspec_1:1;
  };
  byte b;
} u56is_type;
#define u56is (*(volatile u56is_type *)0x01d1)

#define ta0 (*(volatile word *)0x0346)
#define ta1 (*(volatile word *)0x0348)
#define ta2 (*(volatile word *)0x034a)
#define ta3 (*(volatile word *)0x034c)
#define ta4 (*(volatile word *)0x034e)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte mr:3;
    byte tck:2;
  };
  byte b;
} ta0mr_type;
#define ta0mr (*(volatile ta0mr_type *)0x0356)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte mr:3;
    byte tck:2;
  };
  byte b;
} ta1mr_type;
#define ta1mr (*(volatile ta1mr_type *)0x0357)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte mr:3;
    byte tck:2;
  };
  byte b;
} ta2mr_type;
#define ta2mr (*(volatile ta2mr_type *)0x0358)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte mr:3;
    byte tck:2;
  };
  byte b;
} ta3mr_type;
#define ta3mr (*(volatile ta3mr_type *)0x0359)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte mr:3;
    byte tck:2;
  };
  byte b;
} ta4mr_type;
#define ta4mr (*(volatile ta4mr_type *)0x035a)

typedef union {
  struct {
    byte ta0s:1;
    byte ta1s:1;
    byte ta2s:1;
    byte ta3s:1;
    byte ta4s:1;
    byte tb0s:1;
    byte tb1s:1;
    byte tb2s:1;
  };
  byte b;
} tabsr_type;
#define tabsr (*(volatile tabsr_type *)0x0340)

typedef union {
  struct {
    byte ta0ud:1;
    byte ta1ud:1;
    byte ta3ud:1;
    byte ta4ud:1;
    byte ta2p:1;
    byte ta3p:1;
    byte ta4p:1;
  };
  byte b;
} udf_type;
#define udf (*(volatile udf_type *)0x0344)

typedef union {
  struct {
    byte ta0os:1;
    byte ta1os:1;
    byte ta2os:1;
    byte ta3os:1;
    byte ta4os:1;
    byte tazie:1;
    byte ta0tg:2;
  };
  byte b;
} onsf_type;
#define onsf (*(volatile onsf_type *)0x0342)

typedef union {
  struct {
    byte ta1tg:2;
    byte ta2tg:2;
    byte ta3tg:2;
    byte ta4tg:2;
  };
  byte b;
} trgsr_type;
#define trgsr (*(volatile trgsr_type *)0x0343)

typedef union {
  struct {
    byte cnt:4;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte cst:1;
  };
  byte b;
} tcspr_type;
#define tcspr (*(volatile tcspr_type *)0x035f)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps0_type;
#define ps0 (*(volatile ps0_type *)0x03b0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps1_type;
#define ps1 (*(volatile ps1_type *)0x03b1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps2_type;
#define ps2 (*(volatile ps2_type *)0x03b4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps3_type;
#define ps3 (*(volatile ps3_type *)0x03b5)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps4_type;
#define ps4 (*(volatile ps4_type *)0x03b8)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps5_type;
#define ps5 (*(volatile ps5_type *)0x03b9)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps6_type;
#define ps6 (*(volatile ps6_type *)0x03bc)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps7_type;
#define ps7 (*(volatile ps7_type *)0x03bd)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps8_type;
#define ps8 (*(volatile ps8_type *)0x03a0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} ps9_type;
#define ps9 (*(volatile ps9_type *)0x03a1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl0_type;
#define psl0 (*(volatile psl0_type *)0x03b2)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl1_type;
#define psl1 (*(volatile psl1_type *)0x03b3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl2_type;
#define psl2 (*(volatile psl2_type *)0x03b6)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl3_type;
#define psl3 (*(volatile psl3_type *)0x03b7)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl6_type;
#define psl6 (*(volatile psl6_type *)0x03be)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psl9_type;
#define psl9 (*(volatile psl9_type *)0x03a3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psc_type;
#define psc (*(volatile psc_type *)0x03af)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psc2_type;
#define psc2 (*(volatile psc2_type *)0x03ac)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psc3_type;
#define psc3 (*(volatile psc3_type *)0x03ad)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psc6_type;
#define psc6 (*(volatile psc6_type *)0x03aa)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psd1_type;
#define psd1 (*(volatile psd1_type *)0x03a7)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} psd2_type;
#define psd2 (*(volatile psd2_type *)0x03a8)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pse1_type;
#define pse1 (*(volatile pse1_type *)0x03ab)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pse2_type;
#define pse2 (*(volatile pse2_type *)0x03a4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pur0_type;
#define pur0 (*(volatile pur0_type *)0x03f0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pur1_type;
#define pur1 (*(volatile pur1_type *)0x03f1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pur2_type;
#define pur2 (*(volatile pur2_type *)0x03da)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pur3_type;
#define pur3 (*(volatile pur3_type *)0x03db)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pur4_type;
#define pur4 (*(volatile pur4_type *)0x03dc)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pcr_type;
#define pcr (*(volatile pcr_type *)0x03ff)

#define crcd (*(volatile word *)0x037c)
#define crcin (*(volatile byte *)0x037e)
#define dm0sl (*(volatile byte *)0x0378)
#define dm1sl (*(volatile byte *)0x0379)
#define dm2sl (*(volatile byte *)0x037a)
#define dm3sl (*(volatile byte *)0x037b)
#define ta0ic (*(volatile byte *)0x006c)
#define ta1ic (*(volatile byte *)0x008c)
#define ta2ic (*(volatile byte *)0x006e)
#define ta3ic (*(volatile byte *)0x008e)
#define ta4ic (*(volatile byte *)0x0070)
#define tb0ic (*(volatile byte *)0x0094)
#define tb1ic (*(volatile byte *)0x0076)
#define tb2ic (*(volatile byte *)0x0096)
#define tb3ic (*(volatile byte *)0x0078)
#define tb4ic (*(volatile byte *)0x0098)
#define tb5ic (*(volatile byte *)0x0069)
#define s0tic (*(volatile byte *)0x0090)
#define s1tic (*(volatile byte *)0x0092)
#define s2tic (*(volatile byte *)0x0089)
#define s3tic (*(volatile byte *)0x008b)
#define s4tic (*(volatile byte *)0x008d)
#define s0ric (*(volatile byte *)0x0072)
#define s1ric (*(volatile byte *)0x0074)
#define s2ric (*(volatile byte *)0x006b)
#define s3ric (*(volatile byte *)0x006d)
#define s4ric (*(volatile byte *)0x006f)
#define dm0ic (*(volatile byte *)0x0068)
#define dm1ic (*(volatile byte *)0x0088)
#define dm2ic (*(volatile byte *)0x006a)
#define dm3ic (*(volatile byte *)0x008a)
#define ad0ic (*(volatile byte *)0x0073)
#define kupic (*(volatile byte *)0x0093)
#define int0ic (*(volatile byte *)0x009e)
#define int1ic (*(volatile byte *)0x007e)
#define int2ic (*(volatile byte *)0x009c)
#define int3ic (*(volatile byte *)0x007c)
#define int4ic (*(volatile byte *)0x009a)
#define int5ic (*(volatile byte *)0x007a)

#define set_ivect(f,n) \
  asm ("mov.w #%%lo16(%d0),_ivects+%d1"   : : "s" (f), "g" (n*4)); \
  asm ("mov.w #%%hi16(%d0),_ivects+%d1" : : "s" (f), "g" (n*4+2));
